#!/bin/sh
# Preprocessor for 'less'.
# Use with environment variable:  LESSOPEN="|lesspipe.sh %s"

lesspipe() {
  case "$1" in
    *.tar) tar tvvf $1 2>/dev/null ;;
    *.t[ag]z|*.tar.gz|*.tar.[zZ]) tar tzvvf $1 2>/dev/null ;;
    *.tar.bz2) tar tIvvf $1 2>/dev/null ;;
    *.bz2) bzip2 -dc $1 2>/dev/null ;;
    *.zip) unzip -l $1 2>/dev/null ;;
    *.[1-9n]|*.man) [ "$(file -L $1|cut -d ' ' -f 2)" = "troff" ] && \
        groff -s -p -t -e -Tascii -mandoc $1 ;;
    *.[1-9n].gz|*.man.gz)
        [ "$(gzip -dc $1 2>/dev/null|file -|tr -s ' '|cut -d ' ' -f 3)" \
        = "troff" ] && \
        gzip -dc $1 2>/dev/null|groff -s -p -t -e -Tascii -mandoc - ;;
    *.gz|*.[zZ]) gzip -dc $1 2>/dev/null ;;
    *.ms) groff -Tascii -ms $1 2>/dev/null ;;
  esac;
}

lesspipe $1
# end of shell-script lesspipe.sh
